-- AshranBuddy.lua

AshranBuddy = LibStub("AceAddon-3.0"):NewAddon("AshranBuddy", "AceConsole-3.0")
AshranBuddy.modules = { }

local ASHRAN_AREA_ID = 978;

-- Code that you want to run when the addon is first loaded goes here.
function AshranBuddy:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("AshranBuddyDB", self.defaults)
	
	self:RegisterChatCommand("ashranbuddy", "OnChatCommand")
	self:RegisterChatCommand("ab", "OnChatCommand")
end

-- Called when the addon is enabled
function AshranBuddy:OnEnable()
	-- Register events

	-- Enable modules
	for key, module in pairs(self.modules) do
		module:Enable()
		--[[if self.db.modules[key] then
			module:Enable()
		else
			module:Disable()
		end]]
	end
	
	self:CreateOptions()

	-- Show first time message
	if (self.db.profile.firstRun == nil or self.db.profile.firstRun == true) then
		self.db.profile.firstRun = false
		self:Print("Welcome to Ashran Buddy!")
	end    
end

-- Called when the addon is disabled
function AshranBuddy:OnDisable()
    -- Unregister events
	self:UnregisterAllEvents()

	-- Disable modules
	for key, module in pairs(self.modules) do
		module:Disable()
	end
end

-- Process the slash command ('input' contains whatever follows the slash command)
function AshranBuddy:OnChatCommand(input)
	if (input == "test") then
	--[[else
		AceDialog = AceDialog or LibStub("AceConfigDialog-3.0")
		AceRegistry = AceRegistry or LibStub("AceConfigRegistry-3.0")

		if not AshranBuddy.options then
			--AshranBuddy:CreateOptions()
			AceDialog:SetDefaultSize("AshranBuddy", 800, 500)
		end

		AceDialog:Open("AshranBuddy")]]
	end

	-- Pass chat commands to active modules
	for key, module in pairs(self.modules) do
		if (module.enabled and type(self.OnEnable) == "function") then
			module:OnChatCommand(input)
		end
	end
end

function AshranBuddy:RegisterModule(name)
	local module = { }
	module.containerFrame = CreateFrame("Frame")
	module.enabled = false

	-- Activity registration
	module.Enable = function(self)
		if not self.enabled then
			self.enabled = true
			if type(self.OnEnable) == "function" then
				self:OnEnable()
			end
		end
	end
	module.Disable = function(self)
		if (self.enabled) then
			self.enabled = false
			if type(self.OnDisable) == "function" then
				self:OnDisable()
			end
		end
	end
	module.IsEnabled = function(self)
		return self.enabled
	end

	-- Event registration
	module.containerFrame.events = { }
	module.containerFrame:SetScript("OnEvent", function(self, event, ...)
		local func = module.containerFrame.events[event]
		if type(module[func]) == "function" then
			module[func](module, event, ...)
		end
	end)
	module.RegisterEvent = function(self, event, func)
		self.containerFrame.events[event] = func or event
		self.containerFrame:RegisterEvent(event)
	end
	module.UnregisterEvent = function(self, event)
		self.containerFrame.events[event] = nil
		self.containerFrame:UnregisterEvent(event)
	end
	module.UnregisterAllEvents = function(self)
		self.containerFrame:UnregisterAllEvents()
	end

	-- Register the module instance
	module.name = key
	self.modules[name] = module

	return module
end

function AshranBuddy:IsInAshran()
	SetMapToCurrentZone()
	return GetCurrentMapAreaID() == ASHRAN_AREA_ID
end